/******************************************************************************/
/* User Level #define Macros                                                  */
/******************************************************************************/
// MP3_03

//#define TMR0REG_START               (0xFFFF - 0x9896)           // 1s
//#define TMR0REG_START               (0xFFFF - 0x0F42)           // 100ms
#define TMR0REG_START               (0xFFFF - 0x07A1)           // 50ms
//#define TMR0REG_START               (0xFFFF - 0x0027)           // 1ms

#define TMR0REG_START_L             (TMR0REG_START & 0xFF)
#define TMR0REG_START_H             (TMR0REG_START >> 8)

#define SEND_SIZE           32

#ifndef _XTAL_FREQ
 #define _XTAL_FREQ 40000000
#endif

#define MP3_SI              PORTBbits.RB2   //    RB2     // output
#define MP3_SCLK            PORTBbits.RB3
#define MP3_CS              PORTBbits.RB4
#define MP3_BSYNC           PORTCbits.RC6   //    RC6
#define MP3_DCLK            PORTCbits.RC2
#define MP3_DREQ            PORTCbits.RC4     // input
#define MP3_RS              PORTBbits.RB5     // output

#define SW1                 PORTEbits.RE3
#define SW2                 PORTAbits.RA0

#define LED                 PORTAbits.RA3

#define output_high(p)      ((p) = 1)
#define output_low(p)       ((p) = 0)
#define input(p)            (p)
#define itoc(x)             ('0' + (x))
#define itoh(x)             ('A' + ((x) - 10))
#define itoH(x)             ((x) < 10 ? ('0' + (x)) : ('A' + ((x) - 10)))

//#define MAX_SUBDIRS         32

/******************************************************************************/
/* User Function Prototypes                                                   */
/******************************************************************************/

/* TODO User level functions prototypes (i.e. InitApp) go here */
// user.c
void InitApp(void);         /* I/O and Peripheral Initialization */
void write_to_eeprom(unsigned char address, unsigned char data);
unsigned char read_from_eeprom(unsigned char address);
unsigned short read_from_eeprom_uint16(unsigned char address);
void write_to_eeprom_uint16(unsigned char address, unsigned short data);

// vs.c
void	VS10xxRESET(void);
void	VS10xxCOMM(unsigned char addr, unsigned short arg);
void	VS10xxWR(unsigned char data);
uint8_t VS1033SENDDATA(unsigned char DATA[], UINT br);

// user.c
void    wait_ms(unsigned int ms);

extern uint8_t     VOLUME;
extern uint16_t    ST_AMP, ST_FREQ, SB_AMP, SB_FREQ;
extern uint8_t     STATE_SW1;
extern uint8_t     STATE_SW2;
extern uint16_t    CHATTERING_TMR;
extern uint16_t    SW_CONTINUE_COUNT;
extern uint8_t     LED_BLINK_MODE;
