
#if defined(__XC)
    #include <xc.h>         /* XC8 General Include File */
#elif defined(HI_TECH_C)
    #include <htc.h>        /* HiTech General Include File */
#endif

#include <stdint.h>        /* For uint8_t definition */

#include "system.h"        /* System funct/params, like osc/peripheral config */
#include "user.h"          /* User funct/params, such as InitApp */


void	VS10xxRESET(void){
    VS10xxCOMM(0,0x0004);			//????
    //delay_cycles(256);			//????
    _delay(256);              // XC8
    VS10xxCOMM(0,0x0000);			//1001?????????

    while(!input(MP3_DREQ));			//???????
    VS10xxCOMM(3,0x9000);			// Recommented vlue (4.0X)
    //delay_cycles(256);
    _delay(256);              // XC8
    VS10xxCOMM(11, ((unsigned short)VOLUME<<8)|((unsigned short)VOLUME));
//    _delay(256);              // XC8
//    VS10xxCOMM(2, ((ST_AMP << 12) | (ST_FREQ << 8) | (SB_AMP << 4) | SB_FREQ));
    //delay_cycles(256);
    _delay(256);              // XC8
}

void	VS10xxCOMM(unsigned char addr, unsigned short arg){
    output_low(MP3_CS);
    VS10xxWR(2);
    VS10xxWR(addr);
    VS10xxWR(arg>>8);
    VS10xxWR(arg);
    output_high(MP3_CS);
}

void	VS10xxWR(unsigned char data){
    char i;

    for(i=0;i<8;i++)
    {
        if(data & 0x80)
        {
            output_high(MP3_SI);
        }
        else
        {
            output_low(MP3_SI);
        }
        //delay_cycles(4);
        _delay(4);              // XC8
        output_high(MP3_SCLK);
        //delay_cycles(4);
        _delay(4);              // XC8
        data<<=1;
        output_low(MP3_SCLK);
        //delay_cycles(4);
        _delay(4);              // XC8
    }
    output_high(MP3_SI);
    //delay_cycles(4);
    _delay(4);              // XC8
}

void
VS1033SENDBYTE(unsigned char data){
    int     c;

    output_high(MP3_BSYNC);
    for(c=0; c<8; c++){
        if(data & 0x80){
            output_high(MP3_SI);
        } else {
            output_low(MP3_SI);
        }
        output_high(MP3_DCLK);
        data <<= 1;
        output_low(MP3_DCLK);
        output_low(MP3_BSYNC);
    }
}

void
VS1033SENDZEROS(uint16_t cnt){
    uint16_t    i;

    for (i=0; i<cnt; i++){
        while(!(input(MP3_DREQ)));

        VS1033SENDBYTE(0);
    }
}


uint8_t
VS1033SENDDATA(unsigned char DATA[], UINT br){
    int     i, j, c, sendbyte;
    unsigned char	data;
    int     idxPlay;

    idxPlay = 0;

    for (j=0; j<16; j++){
        while(!(input(MP3_DREQ)));

        if (br >= SEND_SIZE) sendbyte = SEND_SIZE;
        else sendbyte = br;
        for (i=0; i<sendbyte; i++){
            data = *(DATA + idxPlay + i);
            VS1033SENDBYTE(data);
        }

        if (sendbyte < SEND_SIZE){
            break;
        }
        idxPlay += sendbyte;
        br -= sendbyte;
    }

    return (0);
}

